/*******************************************************************************
* 
* Teradek(C) 2009
* MPEG2 transport stream through SPI writer
* 
*******************************************************************************/

#ifndef __QBOXPARSE_H
#define __QBOXPARSE_H

#include <stdint.h>
#include "tsgen.h"
#include "pesgen.h"
#include "refdesign.h"
#include "qboxutil.h"

#define AUDIO_FRAME_TYPE 0
#define VIDEO_I_FRAME_TYPE 1
#define VIDEO_P_FRAME_TYPE 2
#define NULL_FRAME_TYPE 3

typedef struct
{
    int spsFound;
    tstream_t *ts_stream;
    pes_stream_t *pes_stream;
    int firstVideo, firstAudioAAC, firstAudioMP2;
   	//uint32_t cts_prev, cts33_prev;
   	uint8_t video_pes_id;
   	uint8_t audio_pes_id;
   	int buf_size;
   	uint8_t *outbuf;
   	int totalSz;
   	char *buf_tmp;
   	int buf_size_ticks;	// size of H.264 encoder (rate control) buffer in 90kHz ticks
   	int one_pes_per_frame_mode;
   	int ticks_120khz;
   	uint64_t cts_64;
} qboxp_stream_t;


void qbox_stream_init(qboxp_stream_t *qbox_stream, pes_stream_t *pes_stream, tstream_t *ts_stream, uint8_t video_pes_id, uint8_t audio_pes_id, 
	int buf_size_ticks, int buf_size, uint8_t *outbuf);

// parses one QBOX and generates PES packet(s)
int qbox_parse_new_block(qboxp_stream_t *qbox_stream, char *buf, int len);

// converts PES packet(s) to TS
void qbox_parse_gen_ts(qboxp_stream_t *qbox_stream, uint16_t pid);

#endif
