
#include "ServerCommon.h"

#define LED_SEQ_PRIORITY 2
#define LED_BLINKING_RED 8
#define LED_BLINKING_AMBER 9
#define LED_BLINKING_GREEN 10

#define TDWD_DAEMON_ID "tdwd"
#define TDCD_DAEMON_ID "tdcd"
#define TDBOARD_DAEMON_ID "tdbd"

#define RUNNING_FLAG_FILE_NAME "/tmp/rtmp_publish_streaming"

typedef enum _RtmpPublishError {
    NO_ERROR = 0,
    CONNECTION_ERROR,
    PUBLISH_ERROR
}RtmpPublishError;

#define TERADEK_USER_AGENT "Teradek"
#define TERADEK_VER1 = "/1.0"
#define TERADEK_VER2 = "/2.0"

#define USTREAM_FLASHVER "UstreamCompatible_Teradek/1.0"

#define TERADEK_FLASHVER "Teradek/1.0 (compatible; FMSc/1.0)"
#define FMLE_FLASHVER "FMLE/3.0 (compatible; FMSc/1.0)"
#define FMS_FLASHVER "FMS/3,5,4,1003"


#define CHAIN(e,f) { if (e != RTMP_FAIL) { e=(f); }}
#define CHAIN_END(e,msg,ret) { if (e == RTMP_FAIL) { RtmpErrorPrint((msg)); return ret; }}


extern RtmpSendStrmPkt* PublishGenerateCommandMsg (RtmpClient *clientPtr, RTMP_EXACT_MSG_TYPE exactMsgTypeId);

extern RtmpSendStrmPkt* PublishGenerateDataMsg (RtmpClient *clientPtr, RTMP_EXACT_MSG_TYPE exactMsgTypeId);

extern RtmpSendStrmPkt* PublishGenerateProtoCtrlMsg (RtmpClient *clientPtr, RTMP_EXACT_MSG_TYPE exactMsgTypeId);

extern RtmpSendStrmPkt* PublishGenerateUsrCtrlMsg (RtmpClient *clientPtr, RTMP_EXACT_MSG_TYPE exactMsgTypeId);

extern RtmpSendStrmPkt* PublishGenerateRtmpMsg (RtmpClient *clientPtr, RTMP_EXACT_MSG_TYPE exactMsgTypeId);

extern RtmpSendStrmPkt* PublishGeneratePingResponseMsg (RtmpClient *clientPtr, RtmpRecvStrmPkt *recvStrmPkt);

extern RtmpRecvStrmPkt* PublishReadMessage(RtmpClient *rtmpClient);


extern int rtmp_report_error(RtmpPublishError type, char *error_str, ...);
extern int rtmp_report_status(RtmpClient *rtmpClient, PublishState state);

extern INT32 PublishConnectToServer(RtmpClient *rtmpClient);
extern INT32 PublishCreateStream(RtmpClient *rtmpClient);
extern INT32 PublishPublishStream(RtmpClient *rtmpClient);
extern INT32 PublishStartStreaming(RtmpClient *rtmpClient);
extern INT32 PublishDeleteStream(RtmpClient *rtmpClient);
extern INT32 PublishCheckConnection(RtmpClient *rtmpClient);
